************************************************************************
* File (nc_ha_1212_42.f) created on Thu Dec  4 22:23:50 MSK 2008.
************************************************************************
* This is the FORTRAN module (nc_ha_1212_42) to calculate differential
* hard photon Bremsstrahlung for el + el -> h + z process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2008.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_ha_1212_42 (s,spr,ph3,costh3,costh5,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 af,vf,sq,sqspr
      real*8 p1p2,p1p3,p1p4,p1p5,p2p3,p2p4,p2p5,p3p4,p3p5,p4p5
      real*8 ph3,sinph3,cosph3,costh3,sinth3,costh5,sinth5

      real*8 sqrtlselel,isqrtlselel,sqrtlsprzh,isqrtlsprzh
      complex*16 propzspr,propizspr,propzsprc
      real*8 iz1el,iz2el,iz3h,iz4z

      cmz2 = mz2

      af = ael
      vf = vel

      sq = dsqrt(s)
      sqspr = dsqrt(spr)

      cosph3 = dcos(ph3)
      sinph3 = dsin(ph3)
      sinth3 = dsqrt(1d0-costh3**2)
      sinth5 = dsqrt(1d0-costh5**2)

      propizspr = (cmz2-spr)
      propzspr = 1d0/propizspr
      propzsprc = dconjg(propzspr)
      sqrtlselel = sqrt(s**2-2d0*s*(relm2+relm2)+(relm2-relm2)**2)
      isqrtlselel = 1d0/sqrtlselel
      sqrtlsprzh = sqrt(spr**2-2d0*spr*(rzm2+rhm2)+(rzm2-rhm2)**2)
      isqrtlsprzh = 1d0/sqrtlsprzh

      iz1el=
     & +1d0/(mel**2/s+1d0/4*sinth5**2-sinth5**2*mel**2/s)/(s-spr)*(1d0/2
     & +1d0/2*costh5*sqrtlselel/s)

      iz2el=
     & +1d0/(mel**2/s+1d0/4*sinth5**2-sinth5**2*mel**2/s)/(s-spr)*(1d0/2
     & -1d0/2*costh5*sqrtlselel/s)

      p1p2=
     & -1d0/2*s

      p1p3=
     & +(s-spr)*(1d0/8-1d0/8*mz**2/spr+1d0/8*mh**2/spr)
     & +sinph3*sinth3*sinth5*sqrtlsprzh*(-1d0/4*sq/sqspr)
     & +costh3*costh5*sqrtlsprzh*(s-spr)*(1d0/8/spr)
     & +costh3*costh5*sqrtlsprzh*(1d0/4)
     & +costh3*sqrtlsprzh*(s-spr)*(1d0/8/spr)
     & +costh5*(s-spr)*(-1d0/8-1d0/8*mz**2/spr+1d0/8*mh**2/spr)
     & -1d0/4*mz**2+1d0/4*mh**2-1d0/4*s

      p1p4=
     & +(s-spr)*(1d0/8+1d0/8*mz**2/spr-1d0/8*mh**2/spr)
     & +sinph3*sinth3*sinth5*sqrtlsprzh*(1d0/4*sq/sqspr)
     & +costh3*costh5*sqrtlsprzh*(s-spr)*(-1d0/8/spr)
     & +costh3*costh5*sqrtlsprzh*(-1d0/4)
     & +costh3*sqrtlsprzh*(s-spr)*(-1d0/8/spr)
     & +costh5*(s-spr)*(-1d0/8+1d0/8*mz**2/spr-1d0/8*mh**2/spr)
     & +1d0/4*mz**2-1d0/4*mh**2-1d0/4*s

      p2p3=
     & +(s-spr)*(1d0/8-1d0/8*mz**2/spr+1d0/8*mh**2/spr)
     & +sinph3*sinth3*sinth5*sqrtlsprzh*(1d0/4*sq/sqspr)
     & +costh3*costh5*sqrtlsprzh*(s-spr)*(-1d0/8/spr)
     & +costh3*costh5*sqrtlsprzh*(-1d0/4)
     & +costh3*sqrtlsprzh*(s-spr)*(1d0/8/spr)
     & +costh5*(s-spr)*(1d0/8+1d0/8*mz**2/spr-1d0/8*mh**2/spr)
     & -1d0/4*mz**2+1d0/4*mh**2-1d0/4*s

      p2p4=
     & +(s-spr)*(1d0/8+1d0/8*mz**2/spr-1d0/8*mh**2/spr)
     & +sinph3*sinth3*sinth5*sqrtlsprzh*(-1d0/4*sq/sqspr)
     & +costh3*costh5*sqrtlsprzh*(s-spr)*(1d0/8/spr)
     & +costh3*costh5*sqrtlsprzh*(1d0/4)
     & +costh3*sqrtlsprzh*(s-spr)*(-1d0/8/spr)
     & +costh5*(s-spr)*(1d0/8-1d0/8*mz**2/spr+1d0/8*mh**2/spr)
     & +1d0/4*mz**2-1d0/4*mh**2-1d0/4*s

      p3p4=
     & +(s-spr)*(1d0/2)
     & +1d0/2*mz**2+1d0/2*mh**2-1d0/2*s

      p1p5=
     & +(s-spr)*(-1d0/4)
     & +costh5*(s-spr)*(1d0/4)

      p2p5=
     & +(s-spr)*(-1d0/4)
     & +costh5*(s-spr)*(-1d0/4)

      p3p5=
     & +(s-spr)*(-1d0/4-1d0/4*mz**2/spr+1d0/4*mh**2/spr)
     & +costh3*sqrtlsprzh*(s-spr)*(1d0/4/spr)

      p4p5=
     & +(s-spr)*(-1d0/4+1d0/4*mz**2/spr-1d0/4*mh**2/spr)
     & +costh3*sqrtlsprzh*(s-spr)*(-1d0/4/spr)

      hard=
     & +iz1el**2*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha
     & *g**4/ctw**6*qel**2*mw**2*mel**2/s**2/spr*(s-spr)*(1d0/512*p1p2-1
     & d0/256*p1p3*p2p3/mz**2+1d0/256*p2p3*p3p5/mz**2)
     & +iz1el**2*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha
     & *g**4/ctw**6*qel**2*mw**2*mel**2/s**2/spr*(s-spr)**2*(1d0/1024)
     & +iz1el*iz2el*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*al
     & pha*g**4/ctw**6*qel**2*mw**2/s**2/spr*(s-spr)*(-1d0/128*p1p2*p1p3
     & *p2p3/mz**2+1d0/256*p1p2*p1p3*p3p5/mz**2+1d0/256*p1p2*p2p3*p3p5/m
     & z**2+1d0/256*p1p2**2)
     & +iz1el*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha*g*
     & *4/ctw**6*qel**2*mw**2/s**2/spr*(s-spr)*(1d0/512*p1p2-1d0/512*p1p
     & 3*p2p3/mz**2+1d0/512*p1p3**2/mz**2+1d0/512*p2p3*p3p5/mz**2)
     & +iz1el*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha*g*
     & *4/ctw**6*qel**2*mw**2/s**2/spr*(s-spr)**2*(1d0/2048)
     & +iz2el**2*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha
     & *g**4/ctw**6*qel**2*mw**2*mel**2/s**2/spr*(s-spr)*(1d0/512*p1p2-1
     & d0/256*p1p3*p2p3/mz**2+1d0/256*p1p3*p3p5/mz**2)
     & +iz2el**2*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha
     & *g**4/ctw**6*qel**2*mw**2*mel**2/s**2/spr*(s-spr)**2*(1d0/1024)
     & +iz2el*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha*g*
     & *4/ctw**6*qel**2*mw**2/s**2/spr*(s-spr)*(1d0/512*p1p2-1d0/512*p1p
     & 3*p2p3/mz**2+1d0/512*p1p3*p3p5/mz**2+1d0/512*p2p3**2/mz**2)
     & +iz2el*propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha*g*
     & *4/ctw**6*qel**2*mw**2/s**2/spr*(s-spr)**2*(1d0/2048)
     & +propzspr*propzsprc*sqrtlsprzh*(vf**2+af**2)/pi**3*alpha*g**4/ctw
     & **6*qel**2*mw**2/s**2/spr*(s-spr)*(-1d0/1024)

      hard = hard*conhc

      return
      end
